#--*-coding:utf-8-*--

class Cthulhu7th < DiceBot

  def initialize
    #$isDebug = true
    super
  end
  
  def gameName
    'クトゥルフ第7版'
  end
  
  def gameType
    "Cthulhu7th"
  end
  
  def prefixs
     ['CC\(\d+\)', 'CC.*', 'CBR\(\d+,\d+\)', 'FAR\(\d+\)' , 'FAR.*']
  end
  
  def getHelpMessage
    return <<INFO_MESSAGE_TEXT
・1D100の目標値判定で、クリティカル(決定的成功)／極限の成功（技能値の1/5以下で成功）／困難な成功（技能値の1/2以下で成功）／通常成功／失敗／ファンブル(致命的失敗)の自動判定。
　（7版では50以上の達成値で成功する場合にはファンブルは達成値100のみとなり、スペシャルはありません）

・ボーナスダイス、ペナルティダイスがある1D100の目標値判定は、それぞれCCの後に()をつけ判定します。
　()の中はボーナスダイスなら1か2の数字、ペナルティダイスなら-1か-2の数字をつけます。0の場合はCCのみでも判定可能です。
例1）CC(2)<=30
　　　Cthulhu7th：（1D100<=50）→ 66,46,6 → 6 → 極限の成功
例2）CC(-1)<=75
　　　Cthulhu7th：（1D100<=75）→ 82,52 → 82 → 失敗

・組み合わせ判定　(CBR(x,y))
　目標値 x と y で％ロールを行い、成功したかどうかを表示します。
　例）CBR(50,20)
　　　Cthulhu7th : (1d100<=70,20) → 22[困難な成功,失敗] → 部分的成功

・連射（フルオート）判定　(FAR(w,x,y,z)) ※掃射の際には、余分な弾を使う弾数から減らしてから使用するようにしてください。
　wに使う弾数を、xに技能値を入れ、yに故障ナンバー、zにボーナス・ペナルティダイスの数字（-2～2）を入れることによって結果を算出します。ただし、wは1～100まで、x,zは1～100までの数字です。
　使う弾数が0になった時点で、そのラウンドの連射が終了します。弾が余った場合、結果に表示されます。
　ジャムが起きた場合、その段階で（ジャムの回の弾薬は消費せず）ロールを終了します。ジャムが起きず、ファンブルが起きた場合運の低い味方に命中します。
　ダメージ算出は命中数と貫通数から各自で計算するようにお願いします。FAR(w,x,y)の形でも判定可能です。
　成功難易度以下で、極限の成功又は決定的成功を1回するごとに、技能値/10の値の半分（切り上げ）が貫通し技能値/10の値の半分（切捨て）が通常命中します。
　成功難易度以下で、通常成功又は困難な成功を1回するごとに、技能値/10の半分の値（切捨て、最低値1）が通常命中します。
例1）FAR(50,80,98,-1)
　　　Cthulhu7th : ボーナス・ペナルティダイス[-1]
1回目: → 5, 15 → 極限の成功
2回目: → 50, 40, 30 → 通常成功
    難易度が困難な成功に変更
3回目: → 29, 89, 99 → 致命的失敗ジャム
8発が命中、4発が貫通、残弾34発
INFO_MESSAGE_TEXT
  end
 
  def rollDiceCommand(command)
    case command
    when /CC/i
      return getCheckResult(command)  
    when /CBR/i
      return getCombineRoll(command)
    when /FAR/i
      return getFullAutoRoll(command)
    end
    
    return nil
  end
  
   
  def getCheckResult(command) 

    output = ""
    dice_num = 0  #ボーナス・ペナルティダイスの個数
    diff = 0


    if (/CC([-\d]+)<=(\d+)/i =~ command)
      dice_num = $1.to_i
      diff = $2.to_i
    elsif(/CC<=(\d+)/i =~ command)
      diff = $1.to_i
    end
    

    if (diff > 0)
      output += "(1D100<=#{diff})"
      if ((dice_num < 3) and (dice_num > -3))
        output += " ボーナス・ペナルティダイス[#{dice_num}]"
      end      

      if((dice_num >= 0) and (dice_num < 3))
      
        digit, = roll(1, 10)
        digit_n = digit
        if(digit_n == 10)
          digit_n = 0
        end
        i = dice_num
        @arr1 = Array.new
        @arr4 = Array.new
        
        begin
          bounus, = roll(1,10)
          if(bounus == 10)
            bounus = 0
          end
          @arr1.push(bounus)
          total = (bounus * 10) + digit_n
          if (total == 0)
            total = 100
          end
          @arr4.push(total)
          i -= 1
        end while (i >= 0)
        
        output += ' ＞ ' + "#{@arr4.join(", ")}"
        total_n = (@arr1.min * 10) + digit_n
        if(total_n == 0)
          #00の場合の結果を100に置き換える
          total_n = 100  
        end
        
          
        output += ' ＞ ' + "#{total_n}" 
        output += ' ＞ ' + getCheckResultText(total_n, diff)

        elsif((dice_num < 0) and (dice_num > -3))

          digit, = roll(1, 10)
          digit_n = digit
          if(digit_n == 10)
            digit_n = 0
          end
          i = dice_num.abs
          @arr2 = Array.new
          @arr3 = Array.new
          
          begin
            penalty, = roll(1, 10)
            if (penalty == 10)
              penalty = 0
            end
            @arr2.push(penalty)
            total = (penalty *10) + digit_n
            if (total == 0)
              total = 100
            end
            @arr3.push(total)
            i -= 1
          end while (i >= 0)
          
          output += ' ＞ ' + "#{@arr3.join(", ")}"
          total_n = (@arr2.max * 10) + digit_n
          if (total_n == 0)
            total_n = 100
          end
          output += ' ＞ ' + "#{total_n}" 
          output += ' ＞ ' + getCheckResultText(total_n, diff)

        else
          output = "エラー。ボーナス・ペナルティダイスの値は-2～2です。"
      end

    return output
    end
  end
  
  
    
  def getCheckResultText(total_n, diff, fum_num = 0)
    
    result = ""
    
    if((total_n <= diff) and (total_n < 100))
      
      result = "通常成功"
      
      if(total_n <= (diff / 2))
        result = "困難な成功"
      end
      
      if(total_n <= (diff / 5))
        result = "極限の成功"
      end
      
      if(total_n == 1)
        result = "決定的成功"
      end
      
    else
    
      result = "失敗"
    
      if (((fum_num == 1) and (total_n >=96)) and (diff >= 50))
        result = "致命的失敗"
      end
      if ((total_n >= 96) and (diff < 50))
        result = "致命的失敗"
      end
      if ((total_n == 100) and (diff >= 50))
        result = "致命的失敗"
      end
    end
    
    return result
  end
  
  
  def getCombineRoll(command)
    output = "1"
    
    return output unless(/CBR\((\d+),(\d+)\)/i =~ command)
    
    diff_1 = $1.to_i
    diff_2 = $2.to_i
    
    total, = roll(1, 100)
    
    result_1 = getCheckResultText(total, diff_1)
    result_2 = getCheckResultText(total, diff_2)
    
    successList = ["決定的成功", "極限の成功", "困難な成功", "通常成功"]
    
    succesCount = 0
    succesCount += 1 if successList.include?( result_1 )
    succesCount += 1 if successList.include?( result_2 )
    debug("succesCount", succesCount)
    
    rank = 
      if( succesCount >= 2 )
        "成功"
      elsif( succesCount == 1 )
        "部分的成功"
      else
        "失敗"
      end
    
    return "(1d100<=#{diff_1},#{diff_2}) ＞ #{total}[#{result_1},#{result_2}] ＞ #{rank}"
  end
  


  def getFullAutoRoll(command)

    output = ""
    
    if (/FAR\((\d+)(,(\d+))(,(\d+))(,([-\d]+))\)/i =~ command)
      bull = $1.to_i
      diff = $3.to_i
      broken_n = $5.to_i
      @dice_n = $7.to_i
    elsif (/FAR\((\d+)(,(\d+))(,([-\d]+))\)/i =~ command)
      bull = $1.to_i
      diff = $3.to_i
      broken_n = $5.to_i
      @dice_n = 0
    end
    
    if (bull > 100)  #最大で（8回*（PC技能値最大値/10））＝72発しか撃てないはずなので上限
      output += "\n弾薬が多すぎます。装填された弾薬を100発に変更します。\n"
      bull = 100
    end
    if (bull < 0)  
      output += "\n弾薬は正の数です。\n"
      bull = 0
    end
    if (broken_n < 0)
      output += "\n故障ナンバーは正の数です。マイナス記号を外します。\n"
    end
    
    if ((@dice_n < 3) and (@dice_n > -3))
      output += "ボーナス・ペナルティダイス[#{@dice_n}]"
    end  

    broken_n = broken_n.abs
    n = 1
    m = 0
    @total_n = 0
    @successList = Array.new
    @ulsuccessList = Array.new
    successCount = 0
    ulsuccessCount = 0
    dice_num = @dice_n
    hitbull = 0
    ulhitbull = 0
    last = 0
    fum_num = 0
    tithediff = diff / 10
    if ((diff >= 1) and (diff < 10))
      tithediff = 1  #技能値が9以下での最低値保障処理
    end

    begin  #難易度変更用ループ
      begin  #ペナルティダイスを減らしながらロール用ループ
        if ((bull - tithediff) < 0)
          last = 1
        end
        if (bull <= 0)
          bull = 0
          break
        end

        if((dice_num >= 0) and (dice_num < 3))  #ボーナスダイス、素振り時の処理

          digit, = roll(1, 10)
          digit_n = digit
          if(digit_n == 10)
            digit_n = 0
          end
          i = dice_num
          @arr1 = Array.new
          @arr4 = Array.new
          
          begin
            bounus, = roll(1, 10)
            if(bounus == 10)
              bounus = 0
            end
            total = (bounus * 10) + digit_n
            if (total == 0)
              total = 100
            end
            @arr1.push(bounus)
            @arr4.push(total)
            i -= 1
          end while (i >= 0)

          output += "\n#{n}回目:"
          @total_n = (@arr1.min * 10) + digit_n
          if (@total_n == 0)
            @total_n = 100
          end
          output += ' ＞ ' + "#{@arr4.join(", ")}"
          result = getCheckResultText(@total_n, diff, fum_num)
          output += ' ＞ ' + "#{result}"
          n += 1
          dice_num -= 1

        elsif((dice_num < 0) and (dice_num > -3))  #ペナルティダイス時の処理
          digit, = roll(1, 10)
          digit_n = digit
          if(digit_n == 10)
            digit_n = 0
          end
          i = dice_num.abs
          @arr2 = Array.new
          @arr3 = Array.new
          
          begin
            penalty, = roll(1, 10)
            if (penalty == 10)
              penalty = 0
            end
            @arr2.push(penalty)
            total = penalty * 10 + digit_n
            if(total == 0)
              total = 100
            end
            @arr3.push(total)
            i -= 1
          end while (i >= 0)

          output += "\n#{n}回目:"
          @total_n = (@arr2.max)* 10 + digit_n
          if (@total_n == 0)
            @total_n = 100
          end
          output += ' ＞ ' + "#{@arr3.join(", ")}"
          result = getCheckResultText(@total_n, diff, fum_num)
          output += ' ＞ ' + "#{result}"
          n += 1
          dice_num -= 1
        end
        
        #成功と貫通を分けるための処理
        if(m <= 2)
          @successList.replace([])
          if(m <= 1)
            @successList.replace( ["困難な成功"] )
            if(m == 0)
               @successList.replace( ["困難な成功", "通常成功"] )
            end
            @ulsuccessList.replace( ["決定的成功", "極限の成功"] )
          end
        end
        if(m == 3)
          @successList.replace( [] )
          @ulsuccessList.replace( ["決定的成功"] )
        end
          success = 0
          success = 1 if @successList.include?( result ) 
          ulsuccess = 0
          ulsuccess = 1 if @ulsuccessList.include?( result ) 
          successCount += 1 if @successList.include?( result )   #成功の回数
          ulsuccessCount += 1 if @ulsuccessList.include?( result )  #貫通の回数
          

        if ((bull - tithediff) >= 0)
          bull = bull - tithediff
          if (@total_n>= broken_n)
            bull = bull + tithediff
            #ジャムの場合の残弾処理
          end
        end
        
        if (last == 1)  #残弾＜1回の判定で使用する弾 となった時の処理
          if(success == 1)
            successCount -= 1
            if (bull == 1)
              lastbull = 1
              bull += 1  #残弾1での最低値保障処理
            end
            if (@total_n >= broken_n)
              if(lastbull == 1)
                bull -= 1
              end
              hitbull -= bull / 2
              successCount += 1
            end
            hitbull += bull / 2
          end
          if (ulsuccess == 1)
            ulsuccessCount -= 1
            halfbull = bull/2.to_f
            if (@total_n >= broken_n)
              ulhitbull -= halfbull.ceil
              hitbull -= halfbull.floor
              #極限の成功しながらジャムするのは通常ありえない。いらないかも？
            end
            ulhitbull += halfbull.ceil
            hitbull += halfbull.floor
          end
          if (@total_n >= broken_n)
            #残弾が技能値/10以下の場合でのジャムの残弾処理
          else
            bull = 0 #残弾が技能値/10以下の場合での残弾処理
          end
        end
        
        
        if (@total_n >= broken_n)
          if (success == 1)
            if ((diff >= broken_n) and (diff >= @total_n))
              successCount -=1
            end
          end
          output += "ジャム"
          break
        end

      end while (dice_num > -3)

      if (bull == 0)
        break
      end

      if (@total_n >= broken_n)
        break
      end
      
      dice_num += 1
      m += 1
      if (m == 1)
        output += "\n    難易度が困難な成功に変更"
        fum_num = 1  #成功が49以下の出目のみとなるため、ファンブルを上昇させる処理
      end
      if (m == 2)
        output += "\n    難易度が極限の成功に変更"
      end
      if (m == 3)
        output += "\n    難易度が決定的成功に変更"
      end
    end while (m < 4 )


    hard = (diff / 10) / 2
    if ((diff >= 1) and (diff < 10))
      hard = 1  #技能値9以下での最低値保障
    end
    
    impale = tithediff / 2.to_f
    hitbull += impale.floor * ulsuccessCount
    hitbull += hard * successCount #通常命中した弾数の計算
    ulhitbull += impale.ceil * ulsuccessCount  #貫通した弾数の計算
    output += "\n#{hitbull}発が命中、#{ulhitbull}発が貫通、残弾#{bull}発"

    if ((@dice_n > 2) or (@dice_n < -2))
      output = "\nエラー。ボーナス・ペナルティダイスの値は-2～2です。"
    end
  return output
  end
end

